/**
 * Core Services API
 * API covering the [Networking](/iaas/Content/Network/Concepts/overview.htm),
[Compute](/iaas/Content/Compute/Concepts/computeoverview.htm), and
[Block Volume](/iaas/Content/Block/Concepts/overview.htm) services. Use this API
to manage resources such as virtual cloud networks (VCNs), compute instances, and
block storage volumes.

 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Contains the details for the block volume replica
 */
export interface BlockVolumeReplicaDetails {
    /**
     * The display name of the block volume replica. You may optionally specify a *display name* for
     * the block volume replica, otherwise a default is provided.
     *
     */
    "displayName"?: string;
    /**
      * The availability domain of the block volume replica.
  * <p>
  Example: `Uocm:PHX-AD-1`
  *
      */
    "availabilityDomain": string;
}
export declare namespace BlockVolumeReplicaDetails {
    function getJsonObj(obj: BlockVolumeReplicaDetails): object;
    function getDeserializedJsonObj(obj: BlockVolumeReplicaDetails): object;
}
