/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The details used to create a new Database Management private endpoint.
 */
export interface CreateDbManagementPrivateEndpointDetails {
    /**
     * The display name for the private endpoint. It is changeable.
     */
    "name": string;
    /**
     * The OCID of the compartment.
     */
    "compartmentId": string;
    /**
     * The OCID of the subnet.
     */
    "subnetId": string;
    /**
     * The description of the private endpoint.
     */
    "description"?: string;
    /**
     * The OCIDs of the network security groups that the private endpoint belongs to.
     *
     */
    "nsgIds"?: Array<string>;
}
export declare namespace CreateDbManagementPrivateEndpointDetails {
    function getJsonObj(obj: CreateDbManagementPrivateEndpointDetails): object;
    function getDeserializedJsonObj(obj: CreateDbManagementPrivateEndpointDetails): object;
}
