/**
 * Database Migration API
 * Use the Oracle Cloud Infrastructure Database Migration APIs to perform database migration operations.
 * OpenAPI spec version: 20200720
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Optional settings for Data Pump Export and Import jobs
 *
 */
export interface DataPumpSettings {
    /**
     * Data Pump job mode.
     * Refer to [Data Pump Export Modes ](https://docs.oracle.com/en/database/oracle/oracle-database/19/sutil/oracle-data-pump-export-utility.html#GUID-8E497131-6B9B-4CC8-AA50-35F480CAC2C4)
     *
     */
    "jobMode"?: model.DataPumpJobMode;
    "dataPumpParameters"?: model.DataPumpParameters;
    /**
     * Defines remapping to be applied to objects as they are processed.
     * Refer to [METADATA_REMAP Procedure ](https://docs.oracle.com/en/database/oracle/oracle-database/19/arpls/DBMS_DATAPUMP.html#GUID-0FC32790-91E6-4781-87A3-229DE024CB3D)
     *
     */
    "metadataRemaps"?: Array<model.MetadataRemap>;
    "exportDirectoryObject"?: model.DirectoryObject;
    "importDirectoryObject"?: model.DirectoryObject;
}
export declare namespace DataPumpSettings {
    function getJsonObj(obj: DataPumpSettings): object;
    function getDeserializedJsonObj(obj: DataPumpSettings): object;
}
