/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The information about the Generic REST task.
 */
export interface CreateTaskFromRestTask extends model.CreateTaskDetails {
    "authDetails"?: model.AuthDetails;
    "endpoint"?: model.Expression;
    /**
     * The REST method to use.
     */
    "methodType"?: CreateTaskFromRestTask.MethodType;
    /**
     * The headers for the REST call.
     */
    "headers"?: any;
    /**
     * JSON data for payload body.
     */
    "jsonData"?: string;
    /**
     * The invocation type to be used for Generic REST invocation.
     */
    "apiCallMode"?: CreateTaskFromRestTask.ApiCallMode;
    "cancelEndpoint"?: model.Expression;
    /**
     * The REST method to use for canceling the original request.
     */
    "cancelMethodType"?: CreateTaskFromRestTask.CancelMethodType;
    "modelType": string;
}
export declare namespace CreateTaskFromRestTask {
    enum MethodType {
        Get = "GET",
        Post = "POST",
        Patch = "PATCH",
        Delete = "DELETE",
        Put = "PUT"
    }
    enum ApiCallMode {
        Synchronous = "SYNCHRONOUS",
        AsyncOciWorkrequest = "ASYNC_OCI_WORKREQUEST"
    }
    enum CancelMethodType {
        Get = "GET",
        Post = "POST",
        Patch = "PATCH",
        Delete = "DELETE",
        Put = "PUT"
    }
    function getJsonObj(obj: CreateTaskFromRestTask, isParentJsonObj?: boolean): object;
    const modelType = "REST_TASK";
    function getDeserializedJsonObj(obj: CreateTaskFromRestTask, isParentJsonObj?: boolean): object;
}
