/**
 * DevOps API
 * Use the DevOps APIs to create a DevOps project to group the pipelines,  add reference to target deployment environments, add artifacts to deploy,  and create deployment pipelines needed to deploy your software.
 * OpenAPI spec version: 20210630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Specifies Invoke Function stage.
 */
export interface InvokeFunctionDeployStageSummary extends model.DeployStageSummary {
    /**
     * Function environment OCID.
     */
    "functionDeployEnvironmentId": string;
    /**
     * Optional binary artifact OCID user may provide to this stage.
     */
    "deployArtifactId"?: string;
    /**
     * A boolean flag specifies whether this stage executes asynchronously.
     */
    "isAsync": boolean;
    /**
     * A boolean flag specifies whether the invoked function must be validated.
     */
    "isValidationEnabled": boolean;
    "deployStageType": string;
}
export declare namespace InvokeFunctionDeployStageSummary {
    function getJsonObj(obj: InvokeFunctionDeployStageSummary, isParentJsonObj?: boolean): object;
    const deployStageType = "INVOKE_FUNCTION";
    function getDeserializedJsonObj(obj: InvokeFunctionDeployStageSummary, isParentJsonObj?: boolean): object;
}
